# xbim_identity

This is the XBIM Flex Swagger service where you can explore the REST API for the platform.

- API version: 2.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen
For more information, please visit [https://xbim.net](https://xbim.net)

This Dart package was generated using [OpenAPI Generator](https://openapi-generator.tech).

## Requirements

Dart 2.0 or later

## Installation & Usage

### Pub.Dev
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  xbim_identity: ^2.0.0
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:xbim_identity/api.dart';


final api_instance = AuthenticationApi();
final clientId = clientId_example; // String | Client ID
final clientSecret = clientSecret_example; // String | Client secret (password)
final grantType = grantType_example; // String | Grant type must be 'master'
final scope = scope_example; // String | Required API scopes
final userId = userId_example; // String | Xbim Flex user ID
final idpId = idpId_example; // String | External identity provider user ID

try {
    final result = api_instance.getAuthorizationToken(clientId, clientSecret, grantType, scope, userId, idpId);
    print(result);
} catch (e) {
    print('Exception when calling AuthenticationApi->getAuthorizationToken: $e\n');
}

```



## Author

info@xbim.net

