//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class AuthenticationApi {
  AuthenticationApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Get token
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Get token.<br/>Gets an access token using a non-interactive flow. Only available for clients with secrets and owning Master. When no user ID is supplied, master owner user is logged in. Client can only sign in a user created in the same Master..<br/>Return Type: <b>TokenResponse</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] clientId (required):
  ///   Client ID
  ///
  /// * [String] clientSecret (required):
  ///   Client secret (password)
  ///
  /// * [String] grantType (required):
  ///   Grant type must be 'master'
  ///
  /// * [String] scope (required):
  ///   Required API scopes
  ///
  /// * [String] userId:
  ///   Xbim Flex user ID
  ///
  /// * [String] idpId:
  ///   External identity provider user ID
  Future<Response> getAuthorizationTokenWithHttpInfo(String clientId, String clientSecret, String grantType, String scope, { String userId, String idpId, }) async {
    // Verify required params are set.
    if (clientId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: clientId');
    }
    if (clientSecret == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: clientSecret');
    }
    if (grantType == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: grantType');
    }
    if (scope == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: scope');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/tokens";

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>[];
    const contentTypes = <String>['application/x-www-form-urlencoded'];

    if (clientId != null) {
      formParams[r'client_id'] = parameterToString(clientId);
    }
    if (clientSecret != null) {
      formParams[r'client_secret'] = parameterToString(clientSecret);
    }
    if (grantType != null) {
      formParams[r'grant_type'] = parameterToString(grantType);
    }
    if (scope != null) {
      formParams[r'scope'] = parameterToString(scope);
    }
    if (userId != null) {
      formParams[r'user_id'] = parameterToString(userId);
    }
    if (idpId != null) {
      formParams[r'idp_id'] = parameterToString(idpId);
    }

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get token
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Get token.<br/>Gets an access token using a non-interactive flow. Only available for clients with secrets and owning Master. When no user ID is supplied, master owner user is logged in. Client can only sign in a user created in the same Master..<br/>Return Type: <b>TokenResponse</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] clientId (required):
  ///   Client ID
  ///
  /// * [String] clientSecret (required):
  ///   Client secret (password)
  ///
  /// * [String] grantType (required):
  ///   Grant type must be 'master'
  ///
  /// * [String] scope (required):
  ///   Required API scopes
  ///
  /// * [String] userId:
  ///   Xbim Flex user ID
  ///
  /// * [String] idpId:
  ///   External identity provider user ID
  Future<TokenResponse> getAuthorizationToken(String clientId, String clientSecret, String grantType, String scope, { String userId, String idpId, }) async {
    final response = await getAuthorizationTokenWithHttpInfo(clientId, clientSecret, grantType, scope,  userId: userId, idpId: idpId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TokenResponse',) as TokenResponse;
    
    }
    return Future<TokenResponse>.value();
  }
}
