//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class InvitationsApi {
  InvitationsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// List invitations
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List invitations.<br/>Query invitations using OData.  Queries support: $filter, $orderby, $select, $expand(including nested filters, selects and expands), $top, $skip.<br/>Return Type: <b>ODataInvitationList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<Response> id20TenantsTenantIdInvitationsGetWithHttpInfo(String tenantId, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Invitations"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// List invitations
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List invitations.<br/>Query invitations using OData.  Queries support: $filter, $orderby, $select, $expand(including nested filters, selects and expands), $top, $skip.<br/>Return Type: <b>ODataInvitationList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<ODataInvitationList> id20TenantsTenantIdInvitationsGet(String tenantId, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await id20TenantsTenantIdInvitationsGetWithHttpInfo(tenantId,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataInvitationList',) as ODataInvitationList;
    
    }
    return Future<ODataInvitationList>.value();
  }

  /// Despatch invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Despatch invitation.<br/>Sends or Resends an Invitation Email..<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///   The Invitation Guid
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdInvitationsInvitationIdDespatchPostWithHttpInfo(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (invitationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: invitationId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Invitations({invitationId})/Despatch"
      .replaceAll('{invitationId}', invitationId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Despatch invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Despatch invitation.<br/>Sends or Resends an Invitation Email..<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///   The Invitation Guid
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Invitation> id20TenantsTenantIdInvitationsInvitationIdDespatchPost(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdInvitationsInvitationIdDespatchPostWithHttpInfo(invitationId, tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Invitation',) as Invitation;
    
    }
    return Future<Invitation>.value();
  }

  /// Show invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show invitation.<br/>Gets the specified Invitation by its key.<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdInvitationsInvitationIdGetWithHttpInfo(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (invitationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: invitationId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Invitations({invitationId})"
      .replaceAll('{invitationId}', invitationId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Show invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show invitation.<br/>Gets the specified Invitation by its key.<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Invitation> id20TenantsTenantIdInvitationsInvitationIdGet(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdInvitationsInvitationIdGetWithHttpInfo(invitationId, tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Invitation',) as Invitation;
    
    }
    return Future<Invitation>.value();
  }

  /// Update invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update invitation.<br/>Amend an existing invitation and send an email  Open invitation can be amended by authorised users.<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///   The Invitation ID to patch
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [InvitationEdit] invitationEdit:
  ///   The partial Invitation record
  Future<Response> id20TenantsTenantIdInvitationsInvitationIdPatchWithHttpInfo(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, InvitationEdit invitationEdit, }) async {
    // Verify required params are set.
    if (invitationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: invitationId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Invitations({invitationId})"
      .replaceAll('{invitationId}', invitationId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody = invitationEdit;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Update invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update invitation.<br/>Amend an existing invitation and send an email  Open invitation can be amended by authorised users.<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///   The Invitation ID to patch
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [InvitationEdit] invitationEdit:
  ///   The partial Invitation record
  Future<Invitation> id20TenantsTenantIdInvitationsInvitationIdPatch(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, InvitationEdit invitationEdit, }) async {
    final response = await id20TenantsTenantIdInvitationsInvitationIdPatchWithHttpInfo(invitationId, tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, invitationEdit: invitationEdit, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Invitation',) as Invitation;
    
    }
    return Future<Invitation>.value();
  }

  /// Revoke invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Revoke invitation.<br/>Revokes an open invitation..<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///   The Invitation Guid
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdInvitationsInvitationIdRevokePostWithHttpInfo(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (invitationId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: invitationId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Invitations({invitationId})/Revoke"
      .replaceAll('{invitationId}', invitationId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Revoke invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Revoke invitation.<br/>Revokes an open invitation..<br/>Return Type: <b>Invitation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] invitationId (required):
  ///   The Invitation Guid
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Invitation> id20TenantsTenantIdInvitationsInvitationIdRevokePost(String invitationId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdInvitationsInvitationIdRevokePostWithHttpInfo(invitationId, tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Invitation',) as Invitation;
    
    }
    return Future<Invitation>.value();
  }

  /// Create invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create invitation.<br/>Creates a new Invitation. The Invitation will only be sent if 'DraftOnly' is false  The ability to create Tenants is limited by tenant role.<br/>Return Type: <b>DraftInvitation</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [InvitationCreate] invitationCreate:
  Future<Response> id20TenantsTenantIdInvitationsPostWithHttpInfo(String tenantId, { String dollarExpand, String dollarSelect, InvitationCreate invitationCreate, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Invitations"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody = invitationCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Create invitation
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create invitation.<br/>Creates a new Invitation. The Invitation will only be sent if 'DraftOnly' is false  The ability to create Tenants is limited by tenant role.<br/>Return Type: <b>DraftInvitation</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [InvitationCreate] invitationCreate:
  Future<DraftInvitation> id20TenantsTenantIdInvitationsPost(String tenantId, { String dollarExpand, String dollarSelect, InvitationCreate invitationCreate, }) async {
    final response = await id20TenantsTenantIdInvitationsPostWithHttpInfo(tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, invitationCreate: invitationCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'DraftInvitation',) as DraftInvitation;
    
    }
    return Future<DraftInvitation>.value();
  }
}
