//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class MembersApi {
  MembersApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// List members
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List members.<br/>Queries support: $filter, $orderby, $select, $expand(including nested filters, selects and expands), $top, $skip.<br/>Return Type: <b>ODataTenantUserList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<Response> id20TenantsTenantIdMembersGetWithHttpInfo(String tenantId, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Members"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// List members
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List members.<br/>Queries support: $filter, $orderby, $select, $expand(including nested filters, selects and expands), $top, $skip.<br/>Return Type: <b>ODataTenantUserList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<ODataTenantUserList> id20TenantsTenantIdMembersGet(String tenantId, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await id20TenantsTenantIdMembersGetWithHttpInfo(tenantId,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataTenantUserList',) as ODataTenantUserList;
    
    }
    return Future<ODataTenantUserList>.value();
  }

  /// Create Member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create Member.<br/>Creates a new Team member adding an existing user to the tenant  The ability to add users to a limited by tenant role.<br/>Return Type: <b>TenantUser</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [TeamMemberCreate] teamMemberCreate:
  Future<Response> id20TenantsTenantIdMembersPostWithHttpInfo(String tenantId, { String dollarExpand, String dollarSelect, TeamMemberCreate teamMemberCreate, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Members"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody = teamMemberCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Create Member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create Member.<br/>Creates a new Team member adding an existing user to the tenant  The ability to add users to a limited by tenant role.<br/>Return Type: <b>TenantUser</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [TeamMemberCreate] teamMemberCreate:
  Future<TenantUser> id20TenantsTenantIdMembersPost(String tenantId, { String dollarExpand, String dollarSelect, TeamMemberCreate teamMemberCreate, }) async {
    final response = await id20TenantsTenantIdMembersPostWithHttpInfo(tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, teamMemberCreate: teamMemberCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TenantUser',) as TenantUser;
    
    }
    return Future<TenantUser>.value();
  }

  /// Revoke member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Revoke member.<br/>Revokes a user from this Tenant. Requires the Administrator Tenant Role.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The UserId to revoke
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  Future<Response> id20TenantsTenantIdMembersUserIdDeleteWithHttpInfo(String userId, String tenantId,) async {
    // Verify required params are set.
    if (userId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: userId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Members({userId})"
      .replaceAll('{userId}', userId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Revoke member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Revoke member.<br/>Revokes a user from this Tenant. Requires the Administrator Tenant Role.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The UserId to revoke
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  Future<void> id20TenantsTenantIdMembersUserIdDelete(String userId, String tenantId,) async {
    final response = await id20TenantsTenantIdMembersUserIdDeleteWithHttpInfo(userId, tenantId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Show member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show member.<br/>Gets the specified Tenant Member by their userId.<br/>Return Type: <b>TenantUser</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The user id
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdMembersUserIdGetWithHttpInfo(String userId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (userId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: userId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Members({userId})"
      .replaceAll('{userId}', userId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Show member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show member.<br/>Gets the specified Tenant Member by their userId.<br/>Return Type: <b>TenantUser</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The user id
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<TenantUser> id20TenantsTenantIdMembersUserIdGet(String userId, String tenantId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdMembersUserIdGetWithHttpInfo(userId, tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TenantUser',) as TenantUser;
    
    }
    return Future<TenantUser>.value();
  }

  /// Update Member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update Member.<br/>Amend an existing team member's team details  Editing users requires Admin rights on the tenant.<br/>Return Type: <b>TenantUser</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The User ID to patch
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [TeamMemberEdit] teamMemberEdit:
  ///   The partial Team Member record
  Future<Response> id20TenantsTenantIdMembersUserIdPatchWithHttpInfo(String userId, String tenantId, { String dollarExpand, String dollarSelect, TeamMemberEdit teamMemberEdit, }) async {
    // Verify required params are set.
    if (userId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: userId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Members({userId})"
      .replaceAll('{userId}', userId)
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody = teamMemberEdit;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Update Member
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update Member.<br/>Amend an existing team member's team details  Editing users requires Admin rights on the tenant.<br/>Return Type: <b>TenantUser</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The User ID to patch
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [TeamMemberEdit] teamMemberEdit:
  ///   The partial Team Member record
  Future<TenantUser> id20TenantsTenantIdMembersUserIdPatch(String userId, String tenantId, { String dollarExpand, String dollarSelect, TeamMemberEdit teamMemberEdit, }) async {
    final response = await id20TenantsTenantIdMembersUserIdPatchWithHttpInfo(userId, tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, teamMemberEdit: teamMemberEdit, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TenantUser',) as TenantUser;
    
    }
    return Future<TenantUser>.value();
  }
}
