//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class TenantsApi {
  TenantsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Lookup tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lookup tenant.<br/>Gets the specified Tenant by its slug.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] identifier (required):
  ///   The Tenant identifier.
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> getTenantByIdentifierWithHttpInfo(String identifier, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (identifier == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: identifier');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants/GetById(identifier='{identifier}')"
      .replaceAll('{identifier}', identifier);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Lookup tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lookup tenant.<br/>Gets the specified Tenant by its slug.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] identifier (required):
  ///   The Tenant identifier.
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Tenant> getTenantByIdentifier(String identifier, { String dollarExpand, String dollarSelect, }) async {
    final response = await getTenantByIdentifierWithHttpInfo(identifier,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Tenant',) as Tenant;
    
    }
    return Future<Tenant>.value();
  }

  /// Access demo
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Access demo.<br/>Registers user in the 'Demo' tenancy.  Any user can request to be registered in the demo tenancy.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsDemoGetWithHttpInfo({ String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants/Demo";

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Access demo
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Access demo.<br/>Registers user in the 'Demo' tenancy.  Any user can request to be registered in the demo tenancy.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Tenant> id20TenantsDemoGet({ String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsDemoGetWithHttpInfo( dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Tenant',) as Tenant;
    
    }
    return Future<Tenant>.value();
  }

  /// Get demo tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Get demo tenant.<br/>Gets publically known demo tenant id.<br/>Return Type: <b>ODataString</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsDemoTenantIdGetWithHttpInfo({ String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants/DemoTenantId";

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get demo tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Get demo tenant.<br/>Gets publically known demo tenant id.<br/>Return Type: <b>ODataString</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<ODataString> id20TenantsDemoTenantIdGet({ String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsDemoTenantIdGetWithHttpInfo( dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataString',) as ODataString;
    
    }
    return Future<ODataString>.value();
  }

  /// List items
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List items.<br/>List items using OData query conventions: $filter, $orderby, $select, $expand(including nested filters, selects and expands), $top, $skip.<br/>Return Type: <b>ODataTenantList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<Response> id20TenantsGetWithHttpInfo({ String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants";

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// List items
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List items.<br/>List items using OData query conventions: $filter, $orderby, $select, $expand(including nested filters, selects and expands), $top, $skip.<br/>Return Type: <b>ODataTenantList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<ODataTenantList> id20TenantsGet({ String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await id20TenantsGetWithHttpInfo( dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataTenantList',) as ODataTenantList;
    
    }
    return Future<ODataTenantList>.value();
  }

  /// Check identifier
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Check identifier.<br/>Checks the availability of a Tenant identifier.<br/>Return Type: <b>ODataBoolean</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] id (required):
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsIsIdentifierAvailableIdidGetWithHttpInfo(String id, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (id == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: id');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants/IsIdentifierAvailable(id='{id}')"
      .replaceAll('{id}', id);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Check identifier
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Check identifier.<br/>Checks the availability of a Tenant identifier.<br/>Return Type: <b>ODataBoolean</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] id (required):
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<ODataBoolean> id20TenantsIsIdentifierAvailableIdidGet(String id, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsIsIdentifierAvailableIdidGetWithHttpInfo(id,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataBoolean',) as ODataBoolean;
    
    }
    return Future<ODataBoolean>.value();
  }

  /// Create tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create tenant.<br/>Creates a new Tenant for the current user  The ability to create Tenants may be limited by Subscription level.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [TenantCreate] tenantCreate (required):
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsPostWithHttpInfo(TenantCreate tenantCreate, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (tenantCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants";

    // ignore: prefer_final_locals
    Object postBody = tenantCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Create tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create tenant.<br/>Creates a new Tenant for the current user  The ability to create Tenants may be limited by Subscription level.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [TenantCreate] tenantCreate (required):
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Tenant> id20TenantsPost(TenantCreate tenantCreate, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsPostWithHttpInfo(tenantCreate,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Tenant',) as Tenant;
    
    }
    return Future<Tenant>.value();
  }

  /// Delete tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Delete tenant.<br/>Deletes a Tenant.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  Future<Response> id20TenantsTenantIdDeleteWithHttpInfo(String tenantId,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Delete tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Delete tenant.<br/>Deletes a Tenant.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  Future<void> id20TenantsTenantIdDelete(String tenantId,) async {
    final response = await id20TenantsTenantIdDeleteWithHttpInfo(tenantId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Show tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show tenant.<br/>Gets the specified Tenant by its key.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdGetWithHttpInfo(String tenantId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Show tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show tenant.<br/>Gets the specified Tenant by its key.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Tenant> id20TenantsTenantIdGet(String tenantId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdGetWithHttpInfo(tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Tenant',) as Tenant;
    
    }
    return Future<Tenant>.value();
  }

  /// Update tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update tenant.<br/>Update a tenant.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [TenantEdit] tenantEdit (required):
  ///   delta changes
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdPatchWithHttpInfo(String tenantId, TenantEdit tenantEdit, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (tenantEdit == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantEdit');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody = tenantEdit;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Update tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update tenant.<br/>Update a tenant.<br/>Return Type: <b>Tenant</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [TenantEdit] tenantEdit (required):
  ///   delta changes
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Tenant> id20TenantsTenantIdPatch(String tenantId, TenantEdit tenantEdit, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdPatchWithHttpInfo(tenantId, tenantEdit,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Tenant',) as Tenant;
    
    }
    return Future<Tenant>.value();
  }

  /// List subscriptions
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List subscriptions.<br/>Gets a tenant's subscription plans.<br/>Return Type: <b>Subscription</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20TenantsTenantIdSubscriptionGetWithHttpInfo(String tenantId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Tenants({tenantId})/Subscription"
      .replaceAll('{tenantId}', tenantId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// List subscriptions
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List subscriptions.<br/>Gets a tenant's subscription plans.<br/>Return Type: <b>Subscription</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Subscription> id20TenantsTenantIdSubscriptionGet(String tenantId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20TenantsTenantIdSubscriptionGetWithHttpInfo(tenantId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Subscription',) as Subscription;
    
    }
    return Future<Subscription>.value();
  }
}
