//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class UsersApi {
  UsersApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// List Users
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List Users.<br/>Return Type: <b>ODataUserList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<Response> id20UsersGetWithHttpInfo({ String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Users";

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// List Users
  ///
  /// <span style='font-size: 17px;'>Summary:</span>List Users.<br/>Return Type: <b>ODataUserList</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarFilter:
  ///   Restricts the set of items returned. The maximum number of expressions is 1000. The allowed functions are: allfunctions.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  ///
  /// * [String] dollarOrderby:
  ///   Specifies the order in which items are returned. The maximum number of expressions is 5.
  ///
  /// * [int] dollarTop:
  ///   Limits the number of items returned from a collection. The maximum value is 1000.
  ///
  /// * [int] dollarSkip:
  ///   Excludes the specified number of items of the queried collection from the result.
  ///
  /// * [bool] dollarCount:
  ///   Indicates whether the total count of items within a collection are returned in the result.
  Future<ODataUserList> id20UsersGet({ String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await id20UsersGetWithHttpInfo( dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataUserList',) as ODataUserList;
    
    }
    return Future<ODataUserList>.value();
  }

  /// Lookup user
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lookup user.<br/>Gets the specified User by their external key.<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] externalId (required):
  ///   Optional external login ID. This can be used as an alternative key by master users
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20UsersGetByExternalIdExternalIdexternalIdGetWithHttpInfo(String externalId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (externalId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: externalId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Users/GetByExternalId(externalId='{externalId}')"
      .replaceAll('{externalId}', externalId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Lookup user
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lookup user.<br/>Gets the specified User by their external key.<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] externalId (required):
  ///   Optional external login ID. This can be used as an alternative key by master users
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<User> id20UsersGetByExternalIdExternalIdexternalIdGet(String externalId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20UsersGetByExternalIdExternalIdexternalIdGetWithHttpInfo(externalId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'User',) as User;
    
    }
    return Future<User>.value();
  }

  /// Create User
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create User.<br/>Creates a new user.<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [UserCreate] userCreate (required):
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20UsersPostWithHttpInfo(UserCreate userCreate, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (userCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: userCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Users";

    // ignore: prefer_final_locals
    Object postBody = userCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Create User
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Create User.<br/>Creates a new user.<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [UserCreate] userCreate (required):
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<User> id20UsersPost(UserCreate userCreate, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20UsersPostWithHttpInfo(userCreate,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'User',) as User;
    
    }
    return Future<User>.value();
  }

  /// Update User
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update User.<br/>Gets or creates the user based on the external identity. Only usable by master users.   User. ExternalIdentity is required for this call..<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [UserCreate] userCreate (required):
  ///   User to get or create based on the User.ExternalIdentity
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20UsersPutWithHttpInfo(UserCreate userCreate, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (userCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: userCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Users";

    // ignore: prefer_final_locals
    Object postBody = userCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Update User
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Update User.<br/>Gets or creates the user based on the external identity. Only usable by master users.   User. ExternalIdentity is required for this call..<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [UserCreate] userCreate (required):
  ///   User to get or create based on the User.ExternalIdentity
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 2.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<User> id20UsersPut(UserCreate userCreate, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20UsersPutWithHttpInfo(userCreate,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'User',) as User;
    
    }
    return Future<User>.value();
  }

  /// Show User
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show User.<br/>Gets the specified User by their key.<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The key.
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<Response> id20UsersUserIdGetWithHttpInfo(String userId, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (userId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: userId');
    }

    // ignore: prefer_const_declarations
    final path = r"/id/2.0/Users({userId})"
      .replaceAll('{userId}', userId);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Show User
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Show User.<br/>Gets the specified User by their key.<br/>Return Type: <b>User</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] userId (required):
  ///   The key.
  ///
  /// * [String] dollarExpand:
  ///   Indicates the related entities to be represented inline. The maximum depth is 5.
  ///
  /// * [String] dollarSelect:
  ///   Limits the properties returned in the result.
  Future<User> id20UsersUserIdGet(String userId, { String dollarExpand, String dollarSelect, }) async {
    final response = await id20UsersUserIdGetWithHttpInfo(userId,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'User',) as User;
    
    }
    return Future<User>.value();
  }
}
